(* ------------------------------------------------------ *)
(*                      BLNKILL.PAS                       *)
(*  Die Routine demonstriert die Manipulation des 6.Bits  *)
(*  an der Portadresse $3b8. Das Ergebnis ist ein         *)
(*  "inverses Intensivattribut".                          *)
(*           (c) 1989  Michael Plewe & TOOLBOX            *)
(* ------------------------------------------------------ *)
PROGRAM BlinkKiller;

USES Crt;

VAR c : CHAR;

  FUNCTION MonoScr : BOOLEAN;
                   { Test, ob Monochromkarte vorhanden ist }
  VAR VideoMode : BYTE ABSOLUTE $0040:$0049;
  BEGIN
    MonoScr := (VideoMode = 7);
  END;

  PROCEDURE BlinkAttrOn;  { Bit setzen }
  BEGIN
    IF MonoScr THEN Port[$3b8] := Port[$3b8] OR $20;
  END;

  PROCEDURE BlinkAttrOff; { Bit lschen }
  BEGIN
    IF MonoScr THEN Port[$3b8] := Port[$3b8] AND $fdf;
  END;

BEGIN
  ClrScr;
  WriteLn('Hallo');  c := ReadKey;

  TextAttr := Black + White * 16;
  BlinkAttrOff;
  WriteLn('Hallo');  c := ReadKey;

  BlinkAttrOn;
  WriteLn('Hallo');  c := ReadKey;

  TextAttr := White + Black * 16;
END.
(* ------------------------------------------------------ *)
(*                 Ende von BLNKILL.PAS                   *)
